## yade 2026.1.0

=== debian/changelog ===
yade (2026.1.0-2ubuntu2) resolute; urgency=medium

  * No-change rebuild for boost 1.90.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 06 Feb 2026 12:29:23 +0100

yade (2026.1.0-2ubuntu1) resolute; urgency=medium

  * Also Disable longdouble on arm64

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 28 Jan 2026 23:27:58 +0100

yade (2026.1.0-2) unstable; urgency=medium

  * [7782e9f] Disable longdouble and float128 builds on amd64

 -- Anton Gladky <gladk@debian.org>  Fri, 23 Jan 2026 18:10:40 +0100

yade (2026.1.0-1) unstable; urgency=medium

  * Upload to unstable.

 -- Anton Gladky <gladk@debian.org>  Wed, 21 Jan 2026 19:53:06 +0100

yade (2026.1.0-1~exp1) experimental; urgency=medium

  * [151be60] New upstream version 2026.1.0
  * [90e5264] Refresh patches
  * [c06f914] Update Standards-Version to 4.7.3

 -- Anton Gladky <gladk@debian.org>  Wed, 21 Jan 2026 07:18:23 +0100
